-- Generated from:  "@(#) src/ll/db/gen/mysql/ll_cfg_resmgr_tables.sql, ll.db.gen, ll_rsnep2, rsnep2s008b 1.33 6/14/12 11:49:36";
-- IBM_PROLOG_BEGIN_TAG 
-- This is an automatically generated prolog. 
--  
--  
--  
-- Licensed Materials - Property of IBM 
--  
-- Restricted Materials of IBM 
--  
-- (C) COPYRIGHT International Business Machines Corp. 2009,2012 
-- All Rights Reserved 
--  
-- US Government Users Restricted Rights - Use, duplication or 
-- disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
--  
-- IBM_PROLOG_END_TAG 
CREATE TABLE TLLR_CFGRegion (
	regionID INTEGER GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1, NO CACHE),
	clusterID INTEGER NOT NULL,
	name VARCHAR(80) NOT NULL, 
	region_mgr_list VARCHAR(2560), 
	PRIMARY KEY (regionID),
	UNIQUE (clusterID, name),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
)  in LLTBS8K;
CREATE TABLE TLLR_CFGMCluster (
	clusterID INTEGER NOT NULL,
	allow_scale_across_jobs CHAR(5), 
	inbound_schedd_port INTEGER, 
	local_flag CHAR(5),  
	main_scale_across_cluster CHAR(5),  
	multicluster_security CHAR(3), 
	secure_schedd_port INTEGER, 
	ssl_cipher_list VARCHAR(80), 
	-- For ListTypes, E for exclude, I for include
	classListType CHAR(1), 
	                       
	groupListType CHAR(1), 
                               
	userListType CHAR(1),  
                               
	PRIMARY KEY (clusterID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
)  in LLTBS8K;
CREATE TABLE TLLR_CFGMClusterClasses (
	clusterID INTEGER NOT NULL,
	class_name VARCHAR(80) NOT NULL, 
	cluster_name VARCHAR(80) NOT NULL,
	PRIMARY KEY (clusterID, class_name, cluster_name),
	FOREIGN KEY (clusterID) REFERENCES TLLR_CFGMCluster (clusterID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGMClusterGroups (
	clusterID INTEGER NOT NULL,
	group_name VARCHAR(80) NOT NULL,	
	cluster_name VARCHAR(80) NOT NULL,
	PRIMARY KEY (clusterID, group_name, cluster_name),
	FOREIGN KEY (clusterID) REFERENCES TLLR_CFGMCluster (clusterID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGMClusterUsers (
	clusterID INTEGER NOT NULL,
	user_name VARCHAR(80) NOT NULL,
	cluster_name VARCHAR(80) NOT NULL,
	PRIMARY KEY (clusterID, user_name, cluster_name),
	FOREIGN KEY (clusterID) REFERENCES TLLR_CFGMCluster (clusterID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGMClusterInboundHosts ( 
	clusterID INTEGER NOT NULL,
	hostname VARCHAR(256) NOT NULL,
	cluster_name VARCHAR(80) NOT NULL,
	PRIMARY KEY (clusterID, hostname, cluster_name),
	FOREIGN KEY (clusterID) REFERENCES TLLR_CFGMCluster (clusterID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGMClusterOutboundHosts ( 
	clusterID INTEGER NOT NULL,
	hostname VARCHAR(256) NOT NULL,
	cluster_name VARCHAR(80) NOT NULL,
	PRIMARY KEY (clusterID, hostname, cluster_name),
	FOREIGN KEY (clusterID) REFERENCES TLLR_CFGMCluster (clusterID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGMachine (
	nodeID INTEGER NOT NULL,
	name VARCHAR(256), 
	adapter_list VARCHAR(80),
	alias VARCHAR(256),
	-- central_manager replaced by central_manager_list in TLLS_CFGCentralManager
	cpu_speed_scale	CHAR(5),
	feature VARCHAR(1024),
	pool_list VARCHAR(80),
	prestarted_starters INTEGER,
	regionID INTEGER,
         -- on this line so not associated with regionID %st=machine %kw=region
	schedd_fenced CHAR(5), 
	schedd_host CHAR(5), 
	speed DOUBLE, 
	submit_only CHAR(5), 
	schedd_runs_here CHAR(5), 
	startd_runs_here CHAR(5), 
	arch CHAR(20), 
	opsys CHAR(20), 
	machine_mode CHAR(12), 
	master_node_exclusive CHAR(5), 
	max_jobs_scheduled INTEGER, 
	reservation_permitted CHAR(5), 
	dstg_max_starters INTEGER, 
	max_starters INTEGER, 
	provision_node CHAR(6), 
	island VARCHAR(256), 
	power_management_policy VARCHAR(256), 
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE,
	FOREIGN KEY (regionID) REFERENCES TLLR_CFGRegion (regionID) ON DELETE SET NULL
) in LLTBS8K;
CREATE TABLE TLLR_CFGMachineClass ( 
	nodeID INTEGER NOT NULL,
	class_name VARCHAR(80) NOT NULL,
	class_count INTEGER,
	PRIMARY KEY (nodeID, class_name),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGMachineResources ( 
	nodeID INTEGER NOT NULL,
	resource_name VARCHAR(80) NOT NULL,
	resource_count VARCHAR(80),
	PRIMARY KEY (nodeID, resource_name),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGMachineNameServer ( 
	nodeID INTEGER NOT NULL,
	name_server CHAR(5) NOT NULL,
	PRIMARY KEY (nodeID, name_server),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGMachineGroup (
	mgID INTEGER NOT NULL,
	adapter_list VARCHAR(256), 
	cpu_speed_scale CHAR(5), 
	feature VARCHAR(1024), 
	pool_list VARCHAR(80), 
	prestarted_starters INTEGER, 
	regionID INTEGER, 
         -- on this line so not associated with regionID %st=machine_group %kw=region
	schedd_fenced CHAR(5), 
	schedd_host CHAR(5), 
	schedd_runs_here CHAR(5), 
	speed DOUBLE, 
	startd_runs_here CHAR(5), 
	submit_only CHAR(5), 
	machine_mode CHAR(12), 
	master_node_exclusive CHAR(5), 
	max_jobs_scheduled INTEGER, 
	reservation_permitted CHAR(5), 
	dstg_max_starters INTEGER, 
	max_starters INTEGER, 
	provision_node CHAR(6), 
	island VARCHAR(256), 
	power_management_policy VARCHAR(256), 
	PRIMARY KEY (mgID),
	FOREIGN KEY (mgID) REFERENCES TLL_MachineGroup (mgID) ON DELETE CASCADE,
	FOREIGN KEY (regionID) REFERENCES TLLR_CFGRegion (regionID) ON DELETE SET NULL
) in LLTBS8K;
CREATE TABLE TLLR_CFGMachineGroupMachineList ( 
	mgID INTEGER NOT NULL,
	machines VARCHAR(256),
	-- PRIMARY KEY (mgID, machines),
	FOREIGN KEY (mgID) REFERENCES TLL_MachineGroup (mgID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGMachineGroupClass ( 
	mgID INTEGER NOT NULL,
	class_name VARCHAR(80) NOT NULL,
	class_count INTEGER,
	PRIMARY KEY (mgID, class_name),
	FOREIGN KEY (mgID) REFERENCES TLL_MachineGroup (mgID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGMachineGroupResources ( 
	mgID INTEGER NOT NULL,
	resource_name VARCHAR(80) NOT NULL,
	resource_count VARCHAR(80),
	PRIMARY KEY (mgID, resource_name),
	FOREIGN KEY (mgID) REFERENCES TLL_MachineGroup (mgID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGMachineGroupNameServer ( 
	mgID INTEGER NOT NULL,
	name_server CHAR(5) NOT NULL,
	PRIMARY KEY (mgID, name_server),
	FOREIGN KEY (mgID) REFERENCES TLL_MachineGroup (mgID) ON DELETE CASCADE
) in LLTBS8K;
-- ll_res_config_machine_keywords
CREATE TABLE TLLR_CFGMaster (
	nodeID INTEGER NOT NULL,
	master VARCHAR(1024), 
	trunc_master_log_on_open CHAR(5), 
	master_coredump_dir VARCHAR(1024), 
	master_log VARCHAR(1024), 
	master_debug VARCHAR(255), 
	master_debug_buffer VARCHAR(255), 
	max_master_log BIGINT, 
	max_master_log_buffer BIGINT,
	master_dgram_port INTEGER, 
	master_stream_port INTEGER, 
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGKbdd (
	nodeID INTEGER NOT NULL,
	kbdd VARCHAR(1024), 
	trunc_kbdd_log_on_open CHAR(5), 
	kbdd_coredump_dir VARCHAR(1024), 
	kbdd_log VARCHAR(1024), 
	max_kbdd_log BIGINT, 
	max_kbdd_log_buffer BIGINT,
	kbdd_debug VARCHAR(255), 
	kbdd_debug_buffer VARCHAR(255),
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGRegionMgr (
	nodeID INTEGER NOT NULL,
	region_mgr VARCHAR(1024), 
	adapter_heartbeat_retries INTEGER, 
	adapter_heartbeat_interval INTEGER, 
	adapter_heartbeat_port INTEGER, 
	trunc_region_mgr_log_on_open CHAR(5), 
	region_mgr_log VARCHAR(1024), 
	max_region_mgr_log BIGINT, 
	max_region_mgr_log_buffer BIGINT,
	region_mgr_debug VARCHAR(255), 
	region_mgr_debug_buffer VARCHAR(255),
	region_mgr_coredump_dir VARCHAR(1024), 
	region_mgr_stream_port INTEGER, 
	region_mgr_dgram_port INTEGER, 
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGResourceMgr (
	nodeID INTEGER NOT NULL,
	resource_mgr CHAR(80), 
	trunc_resource_mgr_log_on_open CHAR(5), 
	resource_mgr_log VARCHAR(1024), 
	max_resource_mgr_log BIGINT, 
	max_resource_mgr_log_buffer BIGINT,
	resource_mgr_debug VARCHAR(255), 
	resource_mgr_debug_buffer VARCHAR(255),
	resource_mgr_coredump_dir VARCHAR(1024), 
	resource_mgr_stream_port INTEGER, 
	resource_mgr_dgram_port INTEGER, 
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGStartd (
	nodeID INTEGER NOT NULL,
	custom_metric INTEGER, 
	custom_metric_command VARCHAR(1024), 
	startd VARCHAR(1024), 
	startd_log VARCHAR(1024), 
	startd_coredump_dir VARCHAR(1024), 
	trunc_startd_log_on_open CHAR(5), 
	max_startd_log BIGINT, 
	max_startd_log_buffer BIGINT,
	startd_debug VARCHAR(255), 
	startd_debug_buffer VARCHAR(255),
	startd_dgram_port INTEGER, 
	startd_stream_port INTEGER, 
	alloc_exclusive_cpu_per_job CHAR(8), 
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) in LLTBS16K;
CREATE TABLE TLLR_CFGStarter (
	nodeID INTEGER NOT NULL,
	starter VARCHAR(1024), 
	trunc_starter_log_on_open CHAR(5), 
	starter_coredump_dir VARCHAR(1024), 
	starter_log VARCHAR(1024), 
	starter_debug VARCHAR(255), 
	starter_debug_buffer VARCHAR(255),
	max_starter_log BIGINT, 
	max_starter_log_buffer BIGINT,
	sshd_ports VARCHAR(256), 
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGSchedd (
	nodeID INTEGER NOT NULL,
	schedd VARCHAR(1024), 
	trunc_schedd_log_on_open CHAR(5), 
	schedd_log VARCHAR(1024), 
	max_schedd_log BIGINT, 
	max_schedd_log_buffer BIGINT,
	schedd_debug VARCHAR(255), 
	schedd_debug_buffer VARCHAR(255),
	schedd_coredump_dir VARCHAR(1024), 
	schedd_stream_port INTEGER, 
	schedd_status_port INTEGER, 
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGVars (
	clusterID INTEGER NOT NULL,
	var_name VARCHAR(80) NOT NULL,
	var_value VARCHAR(1024),
	PRIMARY KEY (clusterID, var_name),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
) in LLTBS8K;
-- ll_res_config_cluster_keywords.sql
CREATE TABLE TLLR_CFGAcct (
	nodeID INTEGER NOT NULL,
	acct_validation VARCHAR(1024), 
	global_history VARCHAR(1024), 
	history VARCHAR(1024), 
	history_permission CHAR(10), 
	reservation_history VARCHAR(1024), 
	job_acct_q_policy INTEGER, 
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) in LLTBS16K;
CREATE TABLE TLLR_CFGAcctFlags (  
	nodeID INTEGER NOT NULL,
	acct_flag CHAR(10) NOT NULL,
	PRIMARY KEY(nodeID, acct_flag),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGWLM (
	nodeID INTEGER NOT NULL,
	enforce_resource_memory CHAR(5), 
	enforce_resource_policy CHAR(6), 
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGWLMUsage ( 
	nodeID INTEGER NOT NULL,
	enforce_resource_usage CHAR(30) NOT NULL,
	PRIMARY KEY (nodeID, enforce_resource_usage),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGSwitch (
	nodeID INTEGER NOT NULL,
	action_on_switch_table_error VARCHAR(1024), 
	drain_on_switch_table_error CHAR(5), 
	resume_on_switch_table_error_clear CHAR(5), 
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGFileSysMon ( 
	fsID INTEGER GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1, NO CACHE),
	nodeID INTEGER NOT NULL,
	fs_interval INTEGER, 
	PRIMARY KEY (fsID),
	UNIQUE (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) in LLTBS8K;
-- TODO - ll_res_tables.sql -  the following keywords are stored in TLLR_CFGFileSysMonThresholds, need to have some validation to the name 
-- fs_notify VARCHAR(80),
-- fs_suspend VARCHAR(80),
-- fs_terminate VARCHAR(80),
-- inode_notify VARCHAR(80), 
-- inode_suspend VARCHAR(80),
-- inode_terminate VARCHAR(80),
CREATE TABLE TLLR_CFGFileSysMonThresholds ( 
	fsID INTEGER NOT NULL,
	name CHAR(16) NOT NULL,
	lower_threshold VARCHAR(80),
	upper_threshold VARCHAR(80),
	PRIMARY KEY (fsID, name),
	FOREIGN KEY (fsID) REFERENCES TLLR_CFGFileSysMon (fsID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGCkpt (
	nodeID INTEGER NOT NULL,
	ckpt_execute_dir VARCHAR(1024), 
	max_ckpt_interval INTEGER,  
	min_ckpt_interval INTEGER,  
	ckpt_cleanup_interval INTEGER, 
	ckpt_cleanup_program VARCHAR(1024), 
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGSecurity ( 
	nodeID INTEGER NOT NULL,
	sec_admin_group	VARCHAR(80), 
	sec_enablement CHAR(6), 
	sec_services_group VARCHAR(80), 
	sec_imposed_mechs CHAR(4), 
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGDaemons (
	nodeID INTEGER NOT NULL,
	execute_dir VARCHAR(1024), 
	spool_dir VARCHAR(1024),  
	job_epilog VARCHAR(1024), 
	job_user_epilog VARCHAR(1024), 
	job_prolog VARCHAR(1024), 
	job_user_prolog VARCHAR(1024), 
	start_daemons CHAR(5), 
	x_runs_here CHAR(5), 
	polling_frequency INTEGER, 
	polls_per_update INTEGER, 
	update_on_poll_interval_only CHAR(5), 
	schedd_interval INTEGER, 
	client_timeout INTEGER, 
	process_tracking CHAR(5), 
	process_tracking_extension VARCHAR(1024), 
	log_message_threshold INTEGER, 
	obituary_log_length INTEGER, 
	publish_obituaries CHAR(5), 
	savelogs VARCHAR(1024), 
	savelogs_compress_program VARCHAR(1024), 
	job_limit_policy INTEGER, 
	submit_filter VARCHAR(1024), 
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) in LLTBS16K;
CREATE TABLE TLLR_CFGRMCluster ( 
	clusterID INTEGER NOT NULL,
	machine_authenticate CHAR(5), 
	resource_mgr_list VARCHAR(2560), -- decided not normalized because there is a ordering with this list 
	afs_getnewtoken VARCHAR(1024), 
	dce_authentication_pair VARCHAR(1024), 
	reject_on_restricted_login CHAR(5), 
	PRIMARY KEY (clusterID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
) in LLTBS16K;
CREATE TABLE TLLR_CFGRMClusterFloatingResources ( 
	clusterID INTEGER NOT NULL,
	name VARCHAR(80) NOT NULL, 
	resource_count INTEGER,
	PRIMARY KEY (clusterID, name),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGVipServerList ( 
	clusterID INTEGER NOT NULL,
	vipserver VARCHAR(80) NOT NULL, 
	PRIMARY KEY (clusterID, vipserver),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLR_CFGExternalScheduler ( 
	clusterID INTEGER NOT NULL,
	aggregate_adapters CHAR(3), 
	wallclock_enforce CHAR(5), 
	PRIMARY KEY (clusterID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
) in LLTBS8K;
-- [7aq]: coefficients of cluster, gathered by initial program
CREATE TABLE  TLLR_EnergyCoEfficients (
    frequency INTEGER NOT NULL,
	clusterID INTEGER NOT NULL,
    factor_a DOUBLE NOT NULL, 
    factor_b DOUBLE NOT NULL, 
    factor_c DOUBLE NOT NULL, 
    factor_d DOUBLE NOT NULL, 
    factor_e DOUBLE NOT NULL, 
    factor_f DOUBLE NOT NULL, 
    PRIMARY KEY (frequency, clusterID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID)
) in LLTBS8K;
-- [7aq]: energy policy tag for jobs
CREATE TABLE  TLLR_EnergyPolicyTag (
	energy_tag_name VARCHAR(256) NOT NULL,
	userid INTEGER NOT NULL,
	frequency INTEGER NOT NULL,
	clusterID INTEGER NOT NULL,
	job_step_id VARCHAR(280) NOT NULL,
	username VARCHAR(256) NOT NULL,
	last_used_time BIGINT NOT NULL,
	predict_power DOUBLE NOT NULL,
	energy_saving_pct DOUBLE NOT NULL,
	predict_elapse_time INTEGER NOT NULL,
	perf_degrad_pct DOUBLE NOT NULL,
    PRIMARY KEY (energy_tag_name, userid, frequency),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID)
) in LLTBS8K;
