-- sccs_id = "@(#) src/ll/db/gen/mysql/ll_cfg_scheduler_tables.sql, ll.db.gen, ll_rsnep2, rsnep2s015a 1.36 2/6/13";
-- IBM_PROLOG_BEGIN_TAG 
-- This is an automatically generated prolog. 
--  
--  
--  
-- Licensed Materials - Property of IBM 
--  
-- Restricted Materials of IBM 
--  
-- (C) COPYRIGHT International Business Machines Corp. 2009,2013 
-- All Rights Reserved 
--  
-- US Government Users Restricted Rights - Use, duplication or 
-- disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
--  
-- IBM_PROLOG_END_TAG 

CREATE TABLE TLLS_CFGUser (
	userID INTEGER AUTO_INCREMENT,
	clusterID INTEGER NOT NULL,
	name VARCHAR(80) BINARY NOT NULL, -- %st=user %kw=label
	account VARCHAR(80), -- %st=user %kw=account
	default_class VARCHAR(800) BINARY, -- %st=user %kw=default_class
	default_group VARCHAR(80) BINARY, -- %st=user %kw=default_group
	default_interactive_class VARCHAR(80) BINARY, -- %st=user %kw=default_interactive_class
	env_copy CHAR(6), -- %st=user %kw=env_copy
	fair_shares INTEGER, -- %st=user %kw=fair_shares
	max_node INTEGER, -- %st=user %kw=max_node
	max_reservation_duration INTEGER, -- %st=user %kw=max_reservation_duration
	max_reservation_expiration INTEGER, -- %st=user %kw=max_reservation_expiration
	max_reservations INTEGER, -- %st=user %kw=max_reservations
	max_total_tasks INTEGER, -- %st=user %kw=max_total_tasks
	maxidle INTEGER, -- %st=user %kw=maxidle
	maxjobs INTEGER, -- %st=user %kw=maxjobs
	maxqueued INTEGER, -- %st=user %kw=maxqueued
	priority INTEGER, -- %st=user %kw=priority
	total_tasks INTEGER, -- %st=user %kw=total_tasks
	reservation_type CHAR(16), -- %st=user %kw=reservation_type
	cpu_frequency_permitted CHAR(5), -- %st=user %kw=cpu_frequency_permitted
	energy_data_list VARCHAR(1024), -- %st=user %kw=energy_data_list
	UNIQUE (clusterID, name),
	PRIMARY KEY (userID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLS_CFGGroup ( 
	groupID INTEGER AUTO_INCREMENT,
	clusterID INTEGER,
	name VARCHAR(80) BINARY NOT NULL, -- %st=group %kw=label
	admin_list VARCHAR(80), -- %st=group %kw=admin
	env_copy CHAR(6), -- %st=group %kw=env_copy
	fair_shares INTEGER, -- %st=group %kw=fair_shares
	max_node INTEGER, -- %st=group %kw=max_node
	max_reservation_duration INTEGER, -- %st=group %kw=max_reservation_duration
	max_reservation_expiration INTEGER, -- %st=group %kw=max_reservation_expiration
	max_reservations INTEGER, -- %st=group %kw=max_reservations
	max_total_tasks INTEGER, -- %st=group %kw=max_total_tasks
	maxidle INTEGER, -- %st=group %kw=maxidle
	maxjobs INTEGER, -- %st=group %kw=maxjobs
	maxqueued INTEGER, -- %st=group %kw=maxqueued
	priority INTEGER, -- %st=group %kw=priority
	total_tasks INTEGER, -- %st=group %kw=total_tasks 
	userListType CHAR(1),   -- E for exclude, I for include 
               -- %st=group %kw=include_users
               -- %st=group %kw=exclude_users
	reservation_type CHAR(16), -- %st=group %kw=reservation_type
	cpu_frequency_permitted CHAR(5), -- %st=group %kw=cpu_frequency_permitted
	energy_data_list VARCHAR(1024), -- %st=group %kw=energy_data_list
	UNIQUE (name),
	PRIMARY KEY (groupID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLS_CFGGroupUsers (
	groupID INTEGER NOT NULL,
	users VARCHAR(80) BINARY NOT NULL,
	PRIMARY KEY (groupID, users),
	FOREIGN KEY (groupID) REFERENCES TLLS_CFGGroup (groupID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLS_CFGClass (
	classID INTEGER AUTO_INCREMENT,
	clusterID INTEGER NOT NULL,
	name VARCHAR(80) BINARY NOT NULL,  -- %st=class %kw=label
	admin_list VARCHAR(255),  -- %st=class %kw=admin
	allow_scale_across_jobs CHAR(5),  -- %st=class %kw=allow_scale_across_jobs
	ckpt_dir VARCHAR(1024),   -- %st=class %kw=ckpt_dir
	class_comment VARCHAR(200),  -- %st=class %kw=class_comment
	env_copy CHAR(6),  -- %st=class %kw=env_copy
	master_node_requirement CHAR(5),  -- %st=class %kw=master_node_requirement
	max_node INTEGER,  -- %st=class %kw=max_node
	max_protocol_instances INTEGER,  -- %st=class %kw=max_protocol_instances
	max_top_dogs INTEGER,  -- %st=class %kw=max_top_dogs
	max_total_tasks INTEGER,  -- %st=class %kw=max_total_tasks
	maxjobs INTEGER,  -- %st=class %kw=maxjobs
	nice INTEGER,  -- %st=class %kw=nice
	priority INTEGER,  -- %st=class %kw=priority
	smt CHAR(5),  -- %st=class %kw=smt
	striping_with_minimum_networks CHAR(5),  -- %st=class %kw=striping_with_minimum_networks
	total_tasks INTEGER,  -- %st=class %kw=total_tasks
	bgListType CHAR(1),  	-- E for exclude, I for include
               -- %st=class %kw=include_bg
               -- %st=class %kw=exclude_bg
	groupListType CHAR(1),  -- E for exclude, I for include
               -- %st=class %kw=include_groups
               -- %st=class %kw=exclude_groups
	userListType CHAR(1),   -- E for exclude, I for include
               -- %st=class %kw=include_users
               -- %st=class %kw=exclude_users
	provision_job CHAR(5), -- %st=class %kw=provision_job
	restart VARCHAR(3), -- %st=class %kw=restart
	collective_groups INTEGER,  -- %st=class %kw=collective_groups
	imm_send_buffers INTEGER,  -- %st=class %kw=imm_send_buffers
	node_topology INTEGER,  -- %st=class %kw=node_topology
	endpoints INTEGER,  -- %st=class %kw=endpoints
	UNIQUE (clusterID, name),
	PRIMARY KEY (classID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLS_CFGClassLimits (
-- %st=class %kw=as_limit
-- %st=class %kw=core_limit
-- %st=class %kw=cpu_limit
-- %st=class kw=data_limit
-- %st=class %kw=file_limit
-- %st=class %kw=job_cpu_limit
-- %st=class %kw=locks_limit
-- %st=class %kw=memlock_limit
-- %st=class %kw=nofile_limit
-- %st=class %kw=nproc_limit
-- %st=class %kw=rss_limit
-- %st=class %kw=stack_limit
-- %st=class %kw=wall_clock_limit
-- %st=class %kw=default_wall_clock_limit
	classID INTEGER NOT NULL,
	name VARCHAR(80) NOT NULL,
	hardlimit VARCHAR(80),
	softlimit VARCHAR(80),
	PRIMARY KEY (classID, name),
	FOREIGN KEY (classID) REFERENCES TLLS_CFGClass (classID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLS_CFGClassDefaultResources ( -- %st=class %kw=default_resources
	classID INTEGER NOT NULL,
	name VARCHAR(80) NOT NULL,
	resource_count VARCHAR(80),
	PRIMARY KEY (classID, name),
	FOREIGN KEY (classID) REFERENCES TLLS_CFGClass (classID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLS_CFGClassDefaultNodeResources ( -- %st=class %kw=default_node_resources
	classID INTEGER NOT NULL,
	name VARCHAR(80) NOT NULL,
	resource_count VARCHAR(80),
	PRIMARY KEY (classID, name),
	FOREIGN KEY (classID) REFERENCES TLLS_CFGClass (classID) ON DELETE CASCADE
) ENGINE = InnoDB;

CREATE TABLE TLLS_CFGClassMaxResources ( -- %st=class %kw=max_resources
	classID INTEGER NOT NULL,
	name VARCHAR(80) NOT NULL,
	resource_count VARCHAR(80),
	PRIMARY KEY (classID, name),
	FOREIGN KEY (classID) REFERENCES TLLS_CFGClass (classID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLS_CFGClassMaxNodeResources ( -- %st=class %kw=max_node_resources
	classID INTEGER NOT NULL,
	name VARCHAR(80) NOT NULL,
	resource_count VARCHAR(80),
	PRIMARY KEY (classID, name),
	FOREIGN KEY (classID) REFERENCES TLLS_CFGClass (classID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLS_CFGClassBG (
	classID INTEGER NOT NULL,
	bg VARCHAR(80) NOT NULL,
	PRIMARY KEY (classID, bg),
	FOREIGN KEY (classID) REFERENCES TLLS_CFGClass (classID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLS_CFGClassGroups (
	classID INTEGER NOT NULL,
	groups VARCHAR(80) BINARY NOT NULL,
	PRIMARY KEY (classID, groups), 
	FOREIGN KEY (classID) REFERENCES TLLS_CFGClass (classID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLS_CFGClassUsers (
	classID INTEGER NOT NULL,
	users VARCHAR(80) BINARY NOT NULL,
	PRIMARY KEY (classID, users),  
	FOREIGN KEY (classID) REFERENCES TLLS_CFGClass (classID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLS_CFGClassUser (
	classID INTEGER NOT NULL,
	userName VARCHAR(80) BINARY NOT NULL, -- %st=class;user %kw=label
	max_total_tasks INTEGER, -- %st=class;user %kw=max_total_tasks
	maxidle INTEGER, -- %st=class;user %kw=maxidle
	maxjobs INTEGER, -- %st=class;user %kw=maxjobs
	maxqueued INTEGER, -- %st=class;user %kw=maxqueued
	PRIMARY KEY (classID, userName),
	FOREIGN KEY (classID) REFERENCES TLLS_CFGClass (classID) ON DELETE CASCADE
) ENGINE = InnoDB;


-- ll_sch_config_machine_keywords  

CREATE TABLE TLLS_CFGPreempt (
	nodeID INTEGER NOT NULL,
	preemption_support CHAR(10), -- %kw=preemption_support
	default_preempt_method CHAR(2), -- %kw=default_preempt_method
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLS_CFGPreemptClass ( -- %kw=preempt_class
	preemptID INTEGER AUTO_INCREMENT,
	clusterID INTEGER NOT NULL,
	incoming_class VARCHAR(80) BINARY NOT NULL,
	all_or_enough CHAR(6) NOT NULL,
	method CHAR(2) NOT NULL,
	PRIMARY KEY (preemptID),
	UNIQUE(clusterID, incoming_class, all_or_enough, method),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLS_CFGPreemptClassOutgoing (
	preemptID INTEGER NOT NULL,
	outgoing_class VARCHAR(80) BINARY NOT NULL,
	PRIMARY KEY (preemptID, outgoing_class),
	FOREIGN KEY (preemptID) REFERENCES TLLS_CFGPreemptClass (preemptID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLS_CFGPreemptStartClass ( -- %kw=start_class
	startID INTEGER AUTO_INCREMENT,
	clusterID INTEGER NOT NULL,
	incoming_class VARCHAR(80) BINARY NOT NULL,
	PRIMARY KEY (startID),
	UNIQUE (clusterID, incoming_class),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLS_CFGPreemptStartClassRunningTasks (
	startID INTEGER NOT NULL,
	running_class VARCHAR(80) BINARY NOT NULL,
	number_of_tasks integer,
	PRIMARY KEY (startID, running_class),
	FOREIGN KEY (startID) REFERENCES TLLS_CFGPreemptStartClass (startID) ON DELETE CASCADE
) ENGINE = InnoDB;


-- ll_sch_config_cluster_keywords

CREATE TABLE TLLS_CFGCentralManager (
	nodeID INTEGER NOT NULL,
	negotiator VARCHAR(1024), -- %kw=negotiator
	trunc_negotiator_log_on_open CHAR(5), -- %kw=trunc_negotiator_log_on_open
	negotiator_log VARCHAR(1024), -- %kw=negotiator_log
	max_negotiator_log BIGINT, -- %kw=max_negotiator_log
	max_negotiator_log_buffer BIGINT,
	negotiator_debug VARCHAR(255), -- %kw=negotiator_debug
	negotiator_debug_buffer VARCHAR(255),
	negotiator_coredump_dir VARCHAR(1024), -- %kw=negotiator_coredump_dir
	negotiator_cycle_delay INTEGER, -- %kw=negotiator_cycle_delay
	negotiator_cycle_time_limit INTEGER, -- %kw=negotiator_cycle_time_limit
	negotiator_interval INTEGER, -- %kw=negotiator_interval
	negotiator_loadavg_increment DOUBLE, -- %kw=negotiator_loadavg_increment
	negotiator_recalculate_sysprio_interval INTEGER, -- %kw=negotiator_recalculate_sysprio_interval
	negotiator_reject_defer INTEGER, -- %kw=negotiator_reject_defer
	negotiator_rescan_queue INTEGER, -- %kw=negotiator_rescan_queue
	negotiator_remove_completed INTEGER, -- %kw=negotiator_remove_completed
	negotiator_parallel_defer INTEGER, -- %kw=negotiator_parallel_defer
	negotiator_parallel_hold INTEGER, -- %kw=negotiator_parallel_hold
	negotiator_stream_port INTEGER, -- %kw=negotiator_stream_port
	cm_collector_port INTEGER, -- %kw=cm_collector_port
	cm_check_userid CHAR(5), -- %kw=cm_check_userid
	percent_of_s3_required INTEGER, -- %kw=percent_of_s3_required
	max_wait_time_for_top_dogs INTEGER, -- %kw=max_wait_time_for_top_dogs
	top_dogs_dispatched_before_s3 INTEGER, -- %kw=top_dogs_dispatched_before_s3
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLS_CFGScheduler (
	clusterID INTEGER NOT NULL,
	action_on_max_reject CHAR(7), -- %kw=action_on_max_reject
	max_job_reject INTEGER, -- %kw=max_job_reject
	enforce_resource_submission CHAR(5), -- %kw=enforce_resource_submission
	machprio VARCHAR(256), -- %kw=machprio
	max_top_dogs INTEGER, -- %kw=max_top_dogs
	schedd_submit_affinity CHAR(5), -- %kw=schedd_submit_affinity
	sysprio VARCHAR(256), -- %kw=sysprio
	sysprio_threshold_to_ignore_step INTEGER, -- %kw=sysprio_threshold_to_ignore_step
	vm_image_algorithm CHAR(40), -- %kw=vm_image_algorithm
	PRIMARY KEY (clusterID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID)  ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLS_CFGScheduleByResources ( -- %kw=schedule_by_resources
	clusterID INTEGER NOT NULL,
	resource VARCHAR(80) NOT NULL,
	PRIMARY KEY (clusterID, resource),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID)  ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLS_CFGReservation (
	clusterID INTEGER NOT NULL,
	max_reservations INTEGER, -- %kw=max_reservations
	reservation_can_be_exceeded CHAR(5), -- %kw=reservation_can_be_exceeded
	reservation_min_advance_time INTEGER, -- %kw=reservation_min_advance_time
	reservation_priority CHAR(4), -- %kw=reservation_priority
	reservation_setup_time INTEGER, -- %kw=reservation_setup_time
	PRIMARY KEY (clusterID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID)  ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLS_CFGMCluster (
	clusterID INTEGER NOT NULL,
	cluster_metric VARCHAR(1024), -- %kw=cluster_metric 
	cluster_remote_job_filter VARCHAR(1024), -- %kw=cluster_remote_job_filter
	cluster_user_mapper VARCHAR(1024), -- %kw=cluster_user_mapper
	scale_across_scheduling_timeout INTEGER, -- %kw=scale_across_scheduling_timeout
	PRIMARY KEY (clusterID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID)  ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLS_CFGBG ( 
	clusterID INTEGER NOT NULL,
	bg_allow_ll_jobs_only CHAR(5), -- %kw=bg_allow_ll_jobs_only
	bg_cache_blocks CHAR(5), -- %kw=bg_cache_blocks
	bg_enabled CHAR(5), -- %kw=bg_enabled
	bg_min_block_size INTEGER, -- %kw=bg_min_block_size
	bg_enable_passthrough CHAR(5), -- %kw=bg_enable_passthrough
	PRIMARY KEY (clusterID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID)  ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLS_CFGFairShare ( 
	clusterID INTEGER NOT NULL,
	fair_share_interval INTEGER, -- %kw=fair_share_interval
	fair_share_total_shares INTEGER, -- %kw=fair_share_total_shares
	PRIMARY KEY (clusterID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID)  ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLS_CFGDstg (
	clusterID INTEGER NOT NULL,
	dstg_min_scheduling_interval INTEGER, -- %kw=dstg_min_scheduling_interval
	dstg_time CHAR(12), -- %kw=dstg_time
	PRIMARY KEY (clusterID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID)  ON DELETE CASCADE
) ENGINE = InnoDB;

