llbgstatus - Query Blue Gene system status

Use the llbgstatus command to return Blue Gene system status information
in the LoadLeveler cluster.


Syntax


llbgstatus [-? | -H | -v | [-X cluster_list | -X all] [-l | -M all | -M
midplane_list | -B all | -B block_list] | drained]


Flags


-? 
   Provides a short usage message.

-H 
   Provides extended help information.

-v 
   Outputs the name of the command, release number, service level,
   service level date, and operating system used to build the command.

-l 
   Specifies that a long listing be generated describing the Blue Gene
   machine. If -l is not specified, the short description of the Blue
   Gene machine is generated.

-X cluster_list

-X all
   Specifies all or a list of clusters where the llbgstatus command is
   to be run.

-M midplane_list

-M all
   Specifies all or a blank-delimited list of midplane locations in the
   Blue Gene system. Detailed information is displayed for the midplanes
   requested.

-B block_list

-B all
   Specifies all or a blank-delimited list of block names in the Blue
   Gene system. Detailed information is displayed for the blocks
   requested.

drained
   Outputs the midplanes and nodeboards that LoadLeveler dynamically put
   into a drained state.


Description


The llbgstatus command is used to obtain information about the midplanes
and blocks in the Blue Gene system.


Examples


1. To generate the high-level listing, issue:

   llbgstatus    

   You should receive output similar to the following:

   Name         Midplanes       ComputeNodes    InQ Run
   BGQ          1x2x2x2         4096              0   0

2. To generate the long listing of the Blue Gene system, issue: 

   llbgstatus -l    

   You should receive output similar to the following:

           Total Blue Gene Midplanes        8
           Total Blue Gene Compute Nodes    4096
           Machine Size in Midplanes        1x2x2x2
           Machine Size in Compute Nodes    4x8x8x8x2
   
           -- list of midplanes --
   A = 0
   ------------------------------------------------
       D = 1
       =====
                           B=00               B=01
            +--------------------------------------
       C = 1|            R01-M1|            R11-M1|
            |               All|              None|
            |  LL11120510045401|              None|
            |--------------------------------------
       C = 0|            R00-M1|            R10-M1|
            |              None|              None|
            |              None|              None|
            +--------------------------------------
   
       D = 0
       =====
                           B=00               B=01
            +--------------------------------------
       C = 1|            R01-M0|            R11-M0|
            |               All|              None|
            |  LL11120510045401|              None|
            |--------------------------------------
       C = 0|            R00-M0|            R10-M0|
            |            SubDiv|              None|
            |                * |              None|
            +--------------------------------------
   
           -- list of cables --
   Cable Location: B_R00-M0 State: Available Destination: B_R10-M0
   Cable Location: B_R00-M1 State: Available Destination: B_R10-M1
   Cable Location: B_R01-M0 State: Available Destination: B_R11-M0
   Cable Location: B_R01-M1 State: Available Destination: B_R11-M1
   Cable Location: B_R10-M0 State: Available Destination: B_R00-M0
   Cable Location: B_R10-M1 State: Available Destination: B_R00-M1
   Cable Location: B_R11-M0 State: Available Destination: B_R01-M0
   Cable Location: B_R11-M1 State: Available Destination: B_R01-M1
   Cable Location: C_R00-M0 State: Available Destination: C_R01-M0
   Cable Location: C_R00-M1 State: Available Destination: C_R01-M1
   Cable Location: C_R01-M0 State: Available Destination: C_R00-M0
   Cable Location: C_R01-M1 State: Available Destination: C_R00-M1
   Cable Location: C_R10-M0 State: Available Destination: C_R11-M0
   Cable Location: C_R10-M1 State: Available Destination: C_R11-M1
   Cable Location: C_R11-M0 State: Available Destination: C_R10-M0
   Cable Location: C_R11-M1 State: Available Destination: C_R10-M1
   Cable Location: D_R00-M0 State: Available Destination: D_R00-M1
   Cable Location: D_R00-M1 State: Available Destination: D_R00-M0
   Cable Location: D_R01-M0 State: Available Destination: D_R01-M1
   Cable Location: D_R01-M1 State: Available Destination: D_R01-M0
   Cable Location: D_R10-M0 State: Available Destination: D_R10-M1
   Cable Location: D_R10-M1 State: Available Destination: D_R10-M0
   Cable Location: D_R11-M0 State: Available Destination: D_R11-M1
   Cable Location: D_R11-M1 State: Available Destination: D_R11-M0

    
   The midplanes are displayed along with the in-use status and block
   names occupying the midplanes.    

   Valid values for the in-use status are: 

   None     The midplane is not in use.

   All      The midplane is in use by a "large block".

   SubDiv   The midplane is subdivided and is in use by one or more
            small blocks.

3. To display Blue Gene midplane information, issue:

   llbgstatus -M all    

   You should receive output similar to the following:

   Midplane Location: R00-M0
     Midplane State: Available
     Location: (0,0,0,0)
     C-node Memory: 16384 mb
     Number of IOLinks: 16
     In Use: Sub Divided
     Node Board List:
       NodeBoard Location=R00-M0-N00 State=Available Quadrant=Q1 ComputeBlock=S32
       NodeBoard Location=R00-M0-N01 State=Available Quadrant=Q1 ComputeBlock=NONE
       NodeBoard Location=R00-M0-N02 State=Available Quadrant=Q1 ComputeBlock=LL11120510055903
       NodeBoard Location=R00-M0-N03 State=Available Quadrant=Q1 ComputeBlock=LL11120510055903
       NodeBoard Location=R00-M0-N04 State=Available Quadrant=Q2 ComputeBlock=LL11120510054802
       NodeBoard Location=R00-M0-N05 State=Available Quadrant=Q2 ComputeBlock=LL11120510054802
       NodeBoard Location=R00-M0-N06 State=Available Quadrant=Q2 ComputeBlock=LL11120510054802
       NodeBoard Location=R00-M0-N07 State=Available Quadrant=Q2 ComputeBlock=LL11120510054802
       NodeBoard Location=R00-M0-N08 State=Available Quadrant=Q3 ComputeBlock=LL11120513515301
       NodeBoard Location=R00-M0-N09 State=Available Quadrant=Q3 ComputeBlock=LL11120513515301
       NodeBoard Location=R00-M0-N10 State=Available Quadrant=Q3 ComputeBlock=LL11120513515301
       NodeBoard Location=R00-M0-N11 State=Available Quadrant=Q3 ComputeBlock=LL11120513515301
       NodeBoard Location=R00-M0-N12 State=Available Quadrant=Q4 ComputeBlock=NONE
       NodeBoard Location=R00-M0-N13 State=Available Quadrant=Q4 ComputeBlock=NONE
       NodeBoard Location=R00-M0-N14 State=Available Quadrant=Q4 ComputeBlock=NONE
       NodeBoard Location=R00-M0-N15 State=Available Quadrant=Q4 ComputeBlock=NONE
   
   Midplane Location: R10-M0
     Midplane State: Available
     Location: (0,1,0,0)
     C-node Memory: 16384 mb
     Number of IOLinks: 16
     In Use: None
     ComputeBlock: NONE
   
   Midplane Location: R01-M0
     Midplane State: Available
     Location: (0,0,1,0)
     C-node Memory: 16384 mb
     Number of IOLinks: 16
     In Use: All
     ComputeBlock: LL11120510045401
   
   Midplane Location: R11-M0
     Midplane State: Available
     Location: (0,1,1,0)
     C-node Memory: 16384 mb
     Number of IOLinks: 16
     In Use: None
     ComputeBlock: NONE
   ...
   ...

4. To generate Blue Gene block information, issue: 

   llbgstatus -B all    

   You should receive output similar to the following:

   Block Name: LL11120510045401 
     Block Status: Initialized
     Description: LoadLeveler Block
     Owner: root
     Users: vhu
     Connectivity: Torus
     Size: 1024
     Shape: 1x1x1x2
     Number of IOLinks: 32
     IOLinks / Midplane: R01-M0-N04-J06 R01-M0-N12-J06 R01-M0-N06-J06 R01-M0-N02-J06 
     R01-M0-N08-J06 R01-M0-N14-J06 R01-M0-N00-J06 R01-M0-N10-J06 R01-M0-N04-J11 
     R01-M0-N12-J11 R01-M0-N06-J11 R01-M0-N02-J11 R01-M0-N08-J11 R01-M0-N14-J11 
     R01-M0-N00-J11 R01-M0-N10-J11 R01-M1-N12-J06 R01-M1-N06-J06 R01-M1-N08-J06 
     R01-M1-N10-J06 R01-M1-N00-J06 R01-M1-N04-J06 R01-M1-N02-J06 R01-M1-N14-J06 
     R01-M1-N12-J11 R01-M1-N06-J11 R01-M1-N08-J11 R01-M1-N10-J11 R01-M1-N00-J11 
     R01-M1-N04-J11 R01-M1-N02-J11 R01-M1-N14-J11
     MloaderImage: /bgsys/drivers/ppcfloor/boot/firmware
     Node Configuration: CNKDefault
     Small Blocks: False
     Midplane List: R01-M0 R01-M1
   
   Block Name: LL11120510054802 
     Block Status: Initialized
     Description: LoadLeveler Block
     Owner: root
     Users: vhu
     Connectivity: N/A
     Size: 128
     Shape: 1x1x1x1
     Number of IOLinks: 4
     IOLinks / Midplane: R00-M0-N04-J06 R00-M0-N06-J06 R00-M0-N04-J11 R00-M0-N06-J11
     MloaderImage: /bgsys/drivers/ppcfloor/boot/firmware
     Node Configuration: CNKDefault
     Small Blocks: True
     Midplane List: R00-M0
     Node Board List: R00-M0-N04 R00-M0-N05 R00-M0-N06 R00-M0-N07

5. To query cluster "BGQfen3" for the same information as displayed
   above but in a multi-cluster environment, issue:

   llbgstatus -X BGQfen3
   llbgstatus -X BGQfen3 -l
   llbgstatus -X BGQfen3 -M all
   llbgstatus -X BGQfen3 -B all

6. To display the midplanes and nodeboards drained by LoadLeveler,
   issue:

   llbgstatus drained    

   You should receive output similar to the following:

   The following resources are considered drained: 
   
   Midplanes: 
      R10-M0
      R30-M0
   
   NodeBoards:
      R00-M0-N08, R00-M0-N09, R00-M0-N10, R00-M0-N11
      R00-M0-N12, R00-M0-N13, R00-M0-N14, R00-M0-N15


Security


LoadLeveler administrators and users can issue this command.
