//
// header file common for LoadLeveler BlueGene samples
//
#ifndef __BG_COMMON_H__
#define __BG_COMMON_H__ 

#include <string>

static const std::string BGQ_HARDWARE_STATE[] = { 
   "Available",
   "Missing",
   "Error",
   "Service",
   "Some Down",
   "INVALID_HARDWARE_STATE"
}; 

const std::string getHardwareStateString(int idx) {
   return BGQ_HARDWARE_STATE[idx];
}

static const std::string BGQ_BLOCK_STATUS[] = {
   "Allocated",  
   "Booting",  
   "Free",  
   "Initialized",  
   "Terminating",  
   "INVALID_BLOCK_STATUS",  
   ""	// used to inidicate uninitialized
};

const std::string getBlockStatusString(int idx) { 
   return BGQ_BLOCK_STATUS[idx];
}

static const std::string BGQ_QUADRANT[] = {
   "Q1",
   "Q2",
   "Q3",
   "Q4",
   "INVALID_QUADRANT"
};

const std::string getQuadrantString(int idx) { 
   return BGQ_QUADRANT[idx];
}

static const std::string BGQ_SWITCH_IN_USE[] = {
   "NotInUse",
   "IncludedBothPortsInUse",
   "IncludedOutputPortInUse",
   "IncludedInputPortInUse",
   "Wrapped",
   "Passthrough",
   "WrappedPassthrough"
};

const std::string getSwitchInUseString(int idx) { 
   return BGQ_SWITCH_IN_USE[idx];
}

const int MAX_DIMENSION=5;

static const std::string BGQ_DIMENSION[] = {
   "A",
   "B",
   "C", 
   "D",
   "E"
};

static const std::string getDimensionString(int idx) { 
   if (idx >= MAX_DIMENSION) {
       return "InvalidDimension";
   }
   return BGQ_DIMENSION[idx];
}

static const std::string BGQ_CONNECTIVITY[] = {
   "Torus",
   "Mesh",
   "Either",
   "Invalid Connnectivity"
};

static const std::string getConnectivityString(int idx) {
   return BGQ_CONNECTIVITY[idx];
}

static const std::string BGQ_PORT_SETTING[] = {
   "In",
   "Out",
   "Both",
   "Invalid"
};

static const std::string getPortSettingString(int idx) { 
   return BGQ_PORT_SETTING[idx];
}

#endif
